class_name GameEvent extends Resource

# * 事件&剧情管理器： player / release / debug 事件，触发者：玩家/系统（系统触发意味着进入 CG）
# * 事件定义：「通变之谓事」
# * 事件发送机制：玩家进行特定操作后，发送事件进度（开始（注意到），尝试&进度，完成：成功or失败）
# 	* 发送内容
# 		* 时间点：玩家现实时间（系统时间），游戏时长（时间戳），章节剧情时间点（事件编号）
# 		* 地点：场景编号，位置坐标
# 		* 实体：道具/NPC/部署点
# 	* 激发器类型：地图区域（手动部署） / 玩家特定操作（自动发送）/ 实体信号（监听玩家特定操作/状态变化）
# * 事件订阅机制：订阅开始/进度/成功/失败，触发特定响应
# 	* 消费器能力：执行 CG（锁定/无锁定，剧本/特效） / 执行实体变化脚本（赠送/消耗/状态变化）
# * 保存与加载
@export var event_id: int
@export var packed_time: PackedTime
@export var scene: String
@export var scene_position: Vector2
@export var entity: String
@export var entity_action: String
